Index: branches/SHM-dev/cfg/encoder_intra_scalable.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_intra_scalable.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_intra_scalable.cfg	(revision 1437)
@@ -54,5 +54,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
Index: branches/SHM-dev/cfg/encoder_intra_scalable10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_intra_scalable10.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_intra_scalable10.cfg	(revision 1437)
@@ -53,5 +53,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
Index: branches/SHM-dev/cfg/encoder_lowdelay_P_scalable.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_lowdelay_P_scalable.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_lowdelay_P_scalable.cfg	(revision 1437)
@@ -61,5 +61,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 SAOLcuBoundary                : 0           # SAOLcuBoundary using non-deblocked pixels (0: OFF, 1: ON)
Index: branches/SHM-dev/cfg/encoder_lowdelay_P_scalable10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_lowdelay_P_scalable10.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_lowdelay_P_scalable10.cfg	(revision 1437)
@@ -61,5 +61,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 SAOLcuBoundary                : 0           # SAOLcuBoundary using non-deblocked pixels (0: OFF, 1: ON)
Index: branches/SHM-dev/cfg/encoder_lowdelay_scalable.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_lowdelay_scalable.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_lowdelay_scalable.cfg	(revision 1437)
@@ -59,5 +59,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
Index: branches/SHM-dev/cfg/encoder_lowdelay_scalable10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_lowdelay_scalable10.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_lowdelay_scalable10.cfg	(revision 1437)
@@ -59,5 +59,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
Index: branches/SHM-dev/cfg/encoder_randomaccess_scalable.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_randomaccess_scalable.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_randomaccess_scalable.cfg	(revision 1437)
@@ -63,5 +63,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
Index: branches/SHM-dev/cfg/encoder_randomaccess_scalable10.cfg
===================================================================
--- branches/SHM-dev/cfg/encoder_randomaccess_scalable10.cfg	(revision 1382)
+++ branches/SHM-dev/cfg/encoder_randomaccess_scalable10.cfg	(revision 1437)
@@ -63,5 +63,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
+#SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)