Index: /branches/SHM-dev/SHM.xcodeproj/project.pbxproj
===================================================================
--- /branches/SHM-dev/SHM.xcodeproj/project.pbxproj	(revision 1438)
+++ /branches/SHM-dev/SHM.xcodeproj/project.pbxproj	(revision 1439)
@@ -77,5 +77,4 @@
 		6767961211AD623900421804 /* TDecTop.cpp in Sources */ = {isa = PBXBuildFile; fileRef = 6767960411AD623900421804 /* TDecTop.cpp */; };
 		6767961311AD623900421804 /* TDecTop.h in Headers */ = {isa = PBXBuildFile; fileRef = 6767960511AD623900421804 /* TDecTop.h */; };
-		6767963311AD628100421804 /* TEncAnalyze.cpp in Sources */ = {isa = PBXBuildFile; fileRef = 6767961E11AD628100421804 /* TEncAnalyze.cpp */; };
 		6767963411AD628100421804 /* TEncAnalyze.h in Headers */ = {isa = PBXBuildFile; fileRef = 6767961F11AD628100421804 /* TEncAnalyze.h */; };
 		6767963511AD628100421804 /* TEncCavlc.cpp in Sources */ = {isa = PBXBuildFile; fileRef = 6767962011AD628100421804 /* TEncCavlc.cpp */; };
@@ -131,4 +130,14 @@
 		71AD603A11EBC28D00F5F1FE /* libTLibEncoder.a in Frameworks */ = {isa = PBXBuildFile; fileRef = 6767961911AD626F00421804 /* libTLibEncoder.a */; };
 		71AD603B11EBC29600F5F1FE /* libTLibVideoIO.a in Frameworks */ = {isa = PBXBuildFile; fileRef = 6767964B11AD629200421804 /* libTLibVideoIO.a */; };
+		71BA9DD71B7B6137000B0413 /* SEIEncoder.cpp in Sources */ = {isa = PBXBuildFile; fileRef = 71BA9DD51B7B6137000B0413 /* SEIEncoder.cpp */; };
+		71BA9DD81B7B6137000B0413 /* SEIEncoder.h in Headers */ = {isa = PBXBuildFile; fileRef = 71BA9DD61B7B6137000B0413 /* SEIEncoder.h */; };
+		71BA9DE11B7B679A000B0413 /* Debug.cpp in Sources */ = {isa = PBXBuildFile; fileRef = 71BA9DD91B7B679A000B0413 /* Debug.cpp */; };
+		71BA9DE21B7B679A000B0413 /* Debug.h in Headers */ = {isa = PBXBuildFile; fileRef = 71BA9DDA1B7B679A000B0413 /* Debug.h */; };
+		71BA9DE31B7B679A000B0413 /* TComChromaFormat.cpp in Sources */ = {isa = PBXBuildFile; fileRef = 71BA9DDB1B7B679A000B0413 /* TComChromaFormat.cpp */; };
+		71BA9DE41B7B679A000B0413 /* TComChromaFormat.h in Headers */ = {isa = PBXBuildFile; fileRef = 71BA9DDC1B7B679A000B0413 /* TComChromaFormat.h */; };
+		71BA9DE51B7B679A000B0413 /* TComCodingStatistics.h in Headers */ = {isa = PBXBuildFile; fileRef = 71BA9DDD1B7B679A000B0413 /* TComCodingStatistics.h */; };
+		71BA9DE61B7B679A000B0413 /* TComRectangle.h in Headers */ = {isa = PBXBuildFile; fileRef = 71BA9DDE1B7B679A000B0413 /* TComRectangle.h */; };
+		71BA9DE71B7B679A000B0413 /* TComTU.cpp in Sources */ = {isa = PBXBuildFile; fileRef = 71BA9DDF1B7B679A000B0413 /* TComTU.cpp */; };
+		71BA9DE81B7B679A000B0413 /* TComTU.h in Headers */ = {isa = PBXBuildFile; fileRef = 71BA9DE01B7B679A000B0413 /* TComTU.h */; };
 		C3D5A69A190AD6DA005E0EBE /* TCom3DAsymLUT.cpp in Sources */ = {isa = PBXBuildFile; fileRef = C3D5A698190AD6DA005E0EBE /* TCom3DAsymLUT.cpp */; };
 		C3D5A69B190AD6DA005E0EBE /* TCom3DAsymLUT.h in Headers */ = {isa = PBXBuildFile; fileRef = C3D5A699190AD6DA005E0EBE /* TCom3DAsymLUT.h */; };
@@ -289,5 +298,4 @@
 		6767960511AD623900421804 /* TDecTop.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = TDecTop.h; path = source/Lib/TLibDecoder/TDecTop.h; sourceTree = "<group>"; };
 		6767961911AD626F00421804 /* libTLibEncoder.a */ = {isa = PBXFileReference; explicitFileType = archive.ar; includeInIndex = 0; path = libTLibEncoder.a; sourceTree = BUILT_PRODUCTS_DIR; };
-		6767961E11AD628100421804 /* TEncAnalyze.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = TEncAnalyze.cpp; path = source/Lib/TLibEncoder/TEncAnalyze.cpp; sourceTree = "<group>"; };
 		6767961F11AD628100421804 /* TEncAnalyze.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = TEncAnalyze.h; path = source/Lib/TLibEncoder/TEncAnalyze.h; sourceTree = "<group>"; };
 		6767962011AD628100421804 /* TEncCavlc.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = TEncCavlc.cpp; path = source/Lib/TLibEncoder/TEncCavlc.cpp; sourceTree = "<group>"; };
@@ -344,4 +352,14 @@
 		7184647513FAE75800747BF9 /* program_options_lite.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = program_options_lite.cpp; path = source/Lib/TAppCommon/program_options_lite.cpp; sourceTree = "<group>"; };
 		7184647613FAE75800747BF9 /* program_options_lite.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = program_options_lite.h; path = source/Lib/TAppCommon/program_options_lite.h; sourceTree = "<group>"; };
+		71BA9DD51B7B6137000B0413 /* SEIEncoder.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = SEIEncoder.cpp; path = source/Lib/TLibEncoder/SEIEncoder.cpp; sourceTree = "<group>"; };
+		71BA9DD61B7B6137000B0413 /* SEIEncoder.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = SEIEncoder.h; path = source/Lib/TLibEncoder/SEIEncoder.h; sourceTree = "<group>"; };
+		71BA9DD91B7B679A000B0413 /* Debug.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = Debug.cpp; path = source/Lib/TLibCommon/Debug.cpp; sourceTree = "<group>"; };
+		71BA9DDA1B7B679A000B0413 /* Debug.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = Debug.h; path = source/Lib/TLibCommon/Debug.h; sourceTree = "<group>"; };
+		71BA9DDB1B7B679A000B0413 /* TComChromaFormat.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = TComChromaFormat.cpp; path = source/Lib/TLibCommon/TComChromaFormat.cpp; sourceTree = "<group>"; };
+		71BA9DDC1B7B679A000B0413 /* TComChromaFormat.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = TComChromaFormat.h; path = source/Lib/TLibCommon/TComChromaFormat.h; sourceTree = "<group>"; };
+		71BA9DDD1B7B679A000B0413 /* TComCodingStatistics.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = TComCodingStatistics.h; path = source/Lib/TLibCommon/TComCodingStatistics.h; sourceTree = "<group>"; };
+		71BA9DDE1B7B679A000B0413 /* TComRectangle.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = TComRectangle.h; path = source/Lib/TLibCommon/TComRectangle.h; sourceTree = "<group>"; };
+		71BA9DDF1B7B679A000B0413 /* TComTU.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = TComTU.cpp; path = source/Lib/TLibCommon/TComTU.cpp; sourceTree = "<group>"; };
+		71BA9DE01B7B679A000B0413 /* TComTU.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = TComTU.h; path = source/Lib/TLibCommon/TComTU.h; sourceTree = "<group>"; };
 		C3D5A698190AD6DA005E0EBE /* TCom3DAsymLUT.cpp */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.cpp.cpp; name = TCom3DAsymLUT.cpp; path = source/Lib/TLibCommon/TCom3DAsymLUT.cpp; sourceTree = "<group>"; };
 		C3D5A699190AD6DA005E0EBE /* TCom3DAsymLUT.h */ = {isa = PBXFileReference; fileEncoding = 4; lastKnownFileType = sourcecode.c.h; name = TCom3DAsymLUT.h; path = source/Lib/TLibCommon/TCom3DAsymLUT.h; sourceTree = "<group>"; };
@@ -472,26 +490,31 @@
 			isa = PBXGroup;
 			children = (
-				C3D5A698190AD6DA005E0EBE /* TCom3DAsymLUT.cpp */,
-				C3D5A699190AD6DA005E0EBE /* TCom3DAsymLUT.h */,
-				6B635E7516E5EAB60057B313 /* TComUpsampleFilter.h */,
-				6B635E7616E5EAB60057B313 /* TComUpsampleFilter.cpp */,
 				712FAEA81379BA2F00DB5314 /* AccessUnit.h */,
-				712FAEA91379BA2F00DB5314 /* NAL.h */,
-				65EA1B85135744C400988950 /* libmd5.h */,
-				65EA1B86135744C400988950 /* libmd5.c */,
-				65EA1B87135744C400988950 /* MD5.h */,
 				6767959911AD61FC00421804 /* CommonDef.h */,
-				6767959A11AD61FC00421804 /* ContextTables.h */,
 				671E0D3811B6AD8C00F3747B /* ContextModel.cpp */,
 				671E0D3911B6AD8C00F3747B /* ContextModel.h */,
 				671E0D3A11B6AD8C00F3747B /* ContextModel3DBuffer.cpp */,
 				671E0D3B11B6AD8C00F3747B /* ContextModel3DBuffer.h */,
+				6767959A11AD61FC00421804 /* ContextTables.h */,
+				71BA9DD91B7B679A000B0413 /* Debug.cpp */,
+				71BA9DDA1B7B679A000B0413 /* Debug.h */,
+				65EA1B86135744C400988950 /* libmd5.c */,
+				65EA1B85135744C400988950 /* libmd5.h */,
+				65EA1B87135744C400988950 /* MD5.h */,
+				712FAEA91379BA2F00DB5314 /* NAL.h */,
+				71161E9E16A7253F0021E8A8 /* SEI.cpp */,
+				65EA1B941357451300988950 /* SEI.h */,
+				65EA1B91135744FE00988950 /* SEIwrite.cpp */,
+				65EA1B90135744FE00988950 /* SEIwrite.h */,
+				C3D5A698190AD6DA005E0EBE /* TCom3DAsymLUT.cpp */,
+				C3D5A699190AD6DA005E0EBE /* TCom3DAsymLUT.h */,
 				671E0D3E11B6AD8C00F3747B /* TComBitCounter.h */,
+				676795A311AD61FC00421804 /* TComBitStream.cpp */,
+				676795A411AD61FC00421804 /* TComBitStream.h */,
 				671E0D3F11B6AD8C00F3747B /* TComCABACTables.cpp */,
 				671E0D4011B6AD8C00F3747B /* TComCABACTables.h */,
-				671E0D4111B6AD8C00F3747B /* TComMv.h */,
-				676795A311AD61FC00421804 /* TComBitStream.cpp */,
-				65EA1B96135745D500988950 /* TComPicYuvMD5.cpp */,
-				676795A411AD61FC00421804 /* TComBitStream.h */,
+				71BA9DDB1B7B679A000B0413 /* TComChromaFormat.cpp */,
+				71BA9DDC1B7B679A000B0413 /* TComChromaFormat.h */,
+				71BA9DDD1B7B679A000B0413 /* TComCodingStatistics.h */,
 				676795A511AD61FC00421804 /* TComDataCU.cpp */,
 				676795A611AD61FC00421804 /* TComDataCU.h */,
@@ -503,4 +526,5 @@
 				676795AA11AD61FC00421804 /* TComMotionInfo.cpp */,
 				676795AB11AD61FC00421804 /* TComMotionInfo.h */,
+				671E0D4111B6AD8C00F3747B /* TComMv.h */,
 				676795AD11AD61FC00421804 /* TComPattern.cpp */,
 				676795AE11AD61FC00421804 /* TComPattern.h */,
@@ -511,4 +535,5 @@
 				676795B311AD61FC00421804 /* TComPicYuv.cpp */,
 				676795B411AD61FC00421804 /* TComPicYuv.h */,
+				65EA1B96135745D500988950 /* TComPicYuvMD5.cpp */,
 				676795B711AD61FC00421804 /* TComPrediction.cpp */,
 				676795B811AD61FC00421804 /* TComPrediction.h */,
@@ -517,4 +542,5 @@
 				DBC9C9471447847400A77A93 /* TComRdCostWeightPrediction.cpp */,
 				DBC9C9481447847400A77A93 /* TComRdCostWeightPrediction.h */,
+				71BA9DDE1B7B679A000B0413 /* TComRectangle.h */,
 				676795BB11AD61FC00421804 /* TComRom.cpp */,
 				676795BC11AD61FC00421804 /* TComRom.h */,
@@ -523,10 +549,10 @@
 				676795BD11AD61FC00421804 /* TComSlice.cpp */,
 				676795BE11AD61FC00421804 /* TComSlice.h */,
-				65EA1B941357451300988950 /* SEI.h */,
-				71161E9E16A7253F0021E8A8 /* SEI.cpp */,
-				65EA1B90135744FE00988950 /* SEIwrite.h */,
-				65EA1B91135744FE00988950 /* SEIwrite.cpp */,
 				676795BF11AD61FC00421804 /* TComTrQuant.cpp */,
 				676795C011AD61FC00421804 /* TComTrQuant.h */,
+				71BA9DDF1B7B679A000B0413 /* TComTU.cpp */,
+				71BA9DE01B7B679A000B0413 /* TComTU.h */,
+				6B635E7616E5EAB60057B313 /* TComUpsampleFilter.cpp */,
+				6B635E7516E5EAB60057B313 /* TComUpsampleFilter.h */,
 				DBC9C9491447847400A77A93 /* TComWeightPrediction.cpp */,
 				DBC9C94A1447847400A77A93 /* TComWeightPrediction.h */,
@@ -541,12 +567,12 @@
 			isa = PBXGroup;
 			children = (
-				71206CD416066EC700A354E7 /* SyntaxElementParser.cpp */,
-				71206CD516066EC700A354E7 /* SyntaxElementParser.h */,
 				712FAEB21379BA6600DB5314 /* AnnexBread.cpp */,
 				712FAEB31379BA6600DB5314 /* AnnexBread.h */,
 				712FAEB41379BA6600DB5314 /* NALread.cpp */,
 				712FAEB51379BA6600DB5314 /* NALread.h */,
+				65EA1B8D135744EA00988950 /* SEIread.cpp */,
 				65EA1B8C135744EA00988950 /* SEIread.h */,
-				65EA1B8D135744EA00988950 /* SEIread.cpp */,
+				71206CD416066EC700A354E7 /* SyntaxElementParser.cpp */,
+				71206CD516066EC700A354E7 /* SyntaxElementParser.h */,
 				671E0D5611B6ADD300F3747B /* TDecBinCoder.h */,
 				671E0D5711B6ADD300F3747B /* TDecBinCoderCABAC.cpp */,
@@ -573,11 +599,14 @@
 			isa = PBXGroup;
 			children = (
-				C3D5A69C190AD6F8005E0EBE /* TEnc3DAsymLUT.cpp */,
-				C3D5A69D190AD6F8005E0EBE /* TEnc3DAsymLUT.h */,
-				71206CD916066EDD00A354E7 /* SyntaxElementWriter.cpp */,
-				71206CDA16066EDD00A354E7 /* SyntaxElementWriter.h */,
 				712FAEAC1379BA4900DB5314 /* AnnexBwrite.h */,
 				712FAEAD1379BA4900DB5314 /* NALwrite.cpp */,
 				712FAEAE1379BA4900DB5314 /* NALwrite.h */,
+				71BA9DD51B7B6137000B0413 /* SEIEncoder.cpp */,
+				71BA9DD61B7B6137000B0413 /* SEIEncoder.h */,
+				71206CD916066EDD00A354E7 /* SyntaxElementWriter.cpp */,
+				71206CDA16066EDD00A354E7 /* SyntaxElementWriter.h */,
+				C3D5A69C190AD6F8005E0EBE /* TEnc3DAsymLUT.cpp */,
+				C3D5A69D190AD6F8005E0EBE /* TEnc3DAsymLUT.h */,
+				6767961F11AD628100421804 /* TEncAnalyze.h */,
 				671E0D7211B6ADE900F3747B /* TEncBinCoder.h */,
 				671E0D7311B6ADE900F3747B /* TEncBinCoderCABAC.cpp */,
@@ -585,6 +614,4 @@
 				DBA796C61499ADE2003F7D5D /* TEncBinCoderCABACCounter.cpp */,
 				DBA796C71499ADE3003F7D5D /* TEncBinCoderCABACCounter.h */,
-				6767961E11AD628100421804 /* TEncAnalyze.cpp */,
-				6767961F11AD628100421804 /* TEncAnalyze.h */,
 				6767962011AD628100421804 /* TEncCavlc.cpp */,
 				6767962111AD628100421804 /* TEncCavlc.h */,
@@ -680,4 +707,5 @@
 				676795CF11AD61FC00421804 /* TComBitStream.h in Headers */,
 				676795D111AD61FC00421804 /* TComDataCU.h in Headers */,
+				71BA9DE21B7B679A000B0413 /* Debug.h in Headers */,
 				676795D211AD61FC00421804 /* TComList.h in Headers */,
 				676795D411AD61FC00421804 /* TComLoopFilter.h in Headers */,
@@ -693,4 +721,5 @@
 				676795E911AD61FC00421804 /* TComSlice.h in Headers */,
 				676795EB11AD61FC00421804 /* TComTrQuant.h in Headers */,
+				71BA9DE81B7B679A000B0413 /* TComTU.h in Headers */,
 				676795ED11AD61FC00421804 /* TComYuv.h in Headers */,
 				676795EE11AD61FC00421804 /* TypeDef.h in Headers */,
@@ -698,5 +727,7 @@
 				671E0D4C11B6AD8C00F3747B /* ContextModel3DBuffer.h in Headers */,
 				671E0D4F11B6AD8C00F3747B /* TComBitCounter.h in Headers */,
+				71BA9DE61B7B679A000B0413 /* TComRectangle.h in Headers */,
 				C3D5A69F190AD6F8005E0EBE /* TEnc3DAsymLUT.h in Headers */,
+				71BA9DE41B7B679A000B0413 /* TComChromaFormat.h in Headers */,
 				671E0D5111B6AD8C00F3747B /* TComCABACTables.h in Headers */,
 				671E0D5211B6AD8C00F3747B /* TComMv.h in Headers */,
@@ -712,4 +743,5 @@
 				DBC9C94C1447847400A77A93 /* TComRdCostWeightPrediction.h in Headers */,
 				DBC9C94E1447847400A77A93 /* TComWeightPrediction.h in Headers */,
+				71BA9DE51B7B679A000B0413 /* TComCodingStatistics.h in Headers */,
 				6B635E7716E5EAB60057B313 /* TComUpsampleFilter.h in Headers */,
 			);
@@ -745,4 +777,5 @@
 				6767963911AD628100421804 /* TEncCu.h in Headers */,
 				6767963B11AD628100421804 /* TEncEntropy.h in Headers */,
+				71BA9DD81B7B6137000B0413 /* SEIEncoder.h in Headers */,
 				6767963D11AD628100421804 /* TEncGOP.h in Headers */,
 				6767963F11AD628100421804 /* TEncSbac.h in Headers */,
@@ -914,5 +947,5 @@
 			attributes = {
 				BuildIndependentTargetsInParallel = YES;
-				LastUpgradeCheck = 0450;
+				LastUpgradeCheck = 0640;
 			};
 			buildConfigurationList = 1DEB923508733DC60010E9CD /* Build configuration list for PBXProject "SHM" */;
@@ -956,5 +989,7 @@
 				C3D5A69A190AD6DA005E0EBE /* TCom3DAsymLUT.cpp in Sources */,
 				676795DE11AD61FC00421804 /* TComPicYuv.cpp in Sources */,
+				71BA9DE31B7B679A000B0413 /* TComChromaFormat.cpp in Sources */,
 				676795E211AD61FC00421804 /* TComPrediction.cpp in Sources */,
+				71BA9DE11B7B679A000B0413 /* Debug.cpp in Sources */,
 				676795E411AD61FC00421804 /* TComRdCost.cpp in Sources */,
 				676795E611AD61FC00421804 /* TComRom.cpp in Sources */,
@@ -967,4 +1002,5 @@
 				65EA1B89135744C400988950 /* libmd5.c in Sources */,
 				65EA1B97135745D500988950 /* TComPicYuvMD5.cpp in Sources */,
+				71BA9DE71B7B679A000B0413 /* TComTU.cpp in Sources */,
 				DBDDB3AB13E26B4400A70251 /* TComInterpolationFilter.cpp in Sources */,
 				DB7795C213F1226500C92469 /* TEncPic.cpp in Sources */,
@@ -1001,6 +1037,6 @@
 			buildActionMask = 2147483647;
 			files = (
-				6767963311AD628100421804 /* TEncAnalyze.cpp in Sources */,
 				6767963511AD628100421804 /* TEncCavlc.cpp in Sources */,
+				71BA9DD71B7B6137000B0413 /* SEIEncoder.cpp in Sources */,
 				6767963811AD628100421804 /* TEncCu.cpp in Sources */,
 				6767963A11AD628100421804 /* TEncEntropy.cpp in Sources */,
@@ -1107,12 +1143,12 @@
 			isa = XCBuildConfiguration;
 			buildSettings = {
-				ARCHS = "$(ARCHS_STANDARD_32_64_BIT)";
 				GCC_C_LANGUAGE_STANDARD = gnu99;
 				GCC_OPTIMIZATION_LEVEL = 0;
 				GCC_WARN_ABOUT_RETURN_TYPE = YES;
+				GCC_WARN_HIDDEN_VIRTUAL_FUNCTIONS = YES;
 				GCC_WARN_UNUSED_VARIABLE = YES;
 				HEADER_SEARCH_PATHS = source/Lib;
 				ONLY_ACTIVE_ARCH = YES;
-				SDKROOT = macosx10.8;
+				SDKROOT = "";
 			};
 			name = Debug;
@@ -1121,12 +1157,12 @@
 			isa = XCBuildConfiguration;
 			buildSettings = {
-				ARCHS = "$(NATIVE_ARCH_ACTUAL)";
 				GCC_C_LANGUAGE_STANDARD = gnu99;
 				GCC_OPTIMIZATION_LEVEL = 3;
 				GCC_WARN_ABOUT_RETURN_TYPE = YES;
+				GCC_WARN_HIDDEN_VIRTUAL_FUNCTIONS = YES;
 				GCC_WARN_NON_VIRTUAL_DESTRUCTOR = YES;
 				GCC_WARN_UNUSED_VARIABLE = YES;
 				HEADER_SEARCH_PATHS = source/Lib;
-				SDKROOT = macosx10.8;
+				SDKROOT = "";
 			};
 			name = Release;
@@ -1143,4 +1179,5 @@
 				INSTALL_PATH = /usr/local/lib;
 				PRODUCT_NAME = TLibCommon;
+				SDKROOT = "";
 			};
 			name = Debug;
@@ -1156,4 +1193,5 @@
 				INSTALL_PATH = /usr/local/lib;
 				PRODUCT_NAME = TLibCommon;
+				SDKROOT = "";
 				ZERO_LINK = NO;
 			};
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 1438)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 1439)
@@ -3024,6 +3024,6 @@
 Int TComVPS::scalTypeToScalIdx( ScalabilityType scalType ) const
 {
-  assert( scalType >= 0 && scalType <= MAX_VPS_NUM_SCALABILITY_TYPES ); 
-  assert( scalType == MAX_VPS_NUM_SCALABILITY_TYPES || getScalabilityMask( scalType ) );
+  assert( (Int)scalType >= 0 && (Int)scalType <= MAX_VPS_NUM_SCALABILITY_TYPES ); 
+  assert( (Int)scalType == MAX_VPS_NUM_SCALABILITY_TYPES || getScalabilityMask( scalType ) );
   Int scalIdx = 0; 
   for( Int curScalType = 0; curScalType < scalType; curScalType++ )
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1438)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1439)
@@ -717,5 +717,4 @@
   UInt                  m_treePartitionLayerIdList[MAX_LAYERS][MAX_LAYERS];
 
-  Int                   m_TolsIdx;
   Bool                  m_subLayerFlagInfoPresentFlag [MAX_VPS_OP_LAYER_SETS_PLUS1];
   Bool                  m_subLayerDpbInfoPresentFlag  [MAX_VPS_OP_LAYER_SETS_PLUS1][MAX_LAYERS];
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1438)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1439)
@@ -3411,5 +3411,5 @@
   else
   {
-    vps->setNumVideoSignalInfo(vps->getMaxLayers() - vps->getBaseLayerInternalFlag() ? 0 : 1);
+    vps->setNumVideoSignalInfo(vps->getMaxLayers() - (vps->getBaseLayerInternalFlag() ? 0 : 1));
   }
 
Index: /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.h	(revision 1438)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/TDecSlice.h	(revision 1439)
@@ -69,8 +69,4 @@
   TDecSbac        m_entropyCodingSyncContextState;      ///< context storate for state of contexts at the wavefront/WPP/entropy-coding-sync second CTU of tile-row
 
-#if SVC_EXTENSION
-  UInt*           m_saoMaxOffsetQVal; 
-#endif 
-
 public:
   TDecSlice();
Index: /branches/SHM-dev/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibEncoder/TEncTop.h	(revision 1438)
+++ /branches/SHM-dev/source/Lib/TLibEncoder/TEncTop.h	(revision 1439)
@@ -143,5 +143,4 @@
   Bool                    m_pocDecrementedInDPBFlag;
   Int                     m_currPocMsb;
-  Bool                    m_prevPicHasEos;
 #endif //SVC_EXTENSION
 protected: