Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 1450)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.cpp	(revision 1451)
@@ -21,19 +21,4 @@
 //! \ingroup TAppEncoder
 //! \{
-
-
-#if AUXILIARY_PICTURES
-static inline ChromaFormat numberToChromaFormat(const Int val)
-{
-  switch (val)
-  {
-    case 400: return CHROMA_400; break;
-    case 420: return CHROMA_420; break;
-    case 422: return CHROMA_422; break;
-    case 444: return CHROMA_444; break;
-    default:  return NUM_CHROMA_FORMAT;
-  }
-}
-#endif
 
 // ====================================================================================================================
@@ -102,12 +87,4 @@
 }
 
-Void TAppEncLayerCfg::create()
-{
-}
-
-Void TAppEncLayerCfg::destroy()
-{
-}
-
 #endif //SVC_EXTENSION
 
Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 1450)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncLayerCfg.h	(revision 1451)
@@ -28,6 +28,6 @@
 protected:
   // file I/O0
-  string    m_inputFileName;                                     ///< source file name
-  string    m_reconFileName;                                     ///< output reconstruction file
+  string    m_inputFileName;                                  ///< source file name
+  string    m_reconFileName;                                  ///< output reconstruction file
   Int       m_layerId;                                        ///< layer Id
   Int       m_iFrameRate;                                     ///< source frame-rates (Hz)
@@ -84,15 +84,15 @@
 
 #if RC_SHVC_HARMONIZATION
-  Bool      m_RCEnableRateControl;                ///< enable rate control or not
-  Int       m_RCTargetBitrate;                    ///< target bitrate when rate control is enabled
-  Bool      m_RCKeepHierarchicalBit;              ///< whether keeping hierarchical bit allocation structure or not
-  Bool      m_RCLCULevelRC;                       ///< true: LCU level rate control; false: picture level rate control
-  Bool      m_RCUseLCUSeparateModel;              ///< use separate R-lambda model at LCU level
-  Int       m_RCInitialQP;                        ///< inital QP for rate control
-  Bool      m_RCForceIntraQP;                     ///< force all intra picture to use initial QP or not
+  Bool      m_RCEnableRateControl;                            ///< enable rate control or not
+  Int       m_RCTargetBitrate;                                ///< target bitrate when rate control is enabled
+  Bool      m_RCKeepHierarchicalBit;                          ///< whether keeping hierarchical bit allocation structure or not
+  Bool      m_RCLCULevelRC;                                   ///< true: LCU level rate control; false: picture level rate control
+  Bool      m_RCUseLCUSeparateModel;                          ///< use separate R-lambda model at LCU level
+  Int       m_RCInitialQP;                                    ///< inital QP for rate control
+  Bool      m_RCForceIntraQP;                                 ///< force all intra picture to use initial QP or not
 #if U0132_TARGET_BITS_SATURATION
-  Bool      m_RCCpbSaturationEnabled;             ///< enable target bits saturation to avoid CPB overflow and underflow
-  UInt      m_RCCpbSize;                          ///< CPB size
-  Double    m_RCInitialCpbFullness;               ///< initial CPB fullness 
+  Bool      m_RCCpbSaturationEnabled;                         ///< enable target bits saturation to avoid CPB overflow and underflow
+  UInt      m_RCCpbSize;                                      ///< CPB size
+  Double    m_RCInitialCpbFullness;                           ///< initial CPB fullness 
 #endif
 #endif
@@ -104,6 +104,6 @@
 
   Int       m_maxTidIlRefPicsPlus1;
-  Int       m_waveFrontSynchro;                   ///< 0: no WPP. >= 1: WPP is enabled, the "Top right" from which inheritance occurs is this LCU offset in the line above the current.
-  Int       m_waveFrontFlush;                     ///< enable(1)/disable(0) the CABAC flush at the end of each line of LCUs.
+  Int       m_waveFrontSynchro;                               ///< 0: no WPP. >= 1: WPP is enabled, the "Top right" from which inheritance occurs is this LCU offset in the line above the current.
+  Int       m_waveFrontFlush;                                 ///< enable(1)/disable(0) the CABAC flush at the end of each line of LCUs.
 
   Int       m_iQP;                                            ///< QP value of key-picture (integer)
@@ -127,5 +127,5 @@
   Int       m_phaseHorChroma[MAX_LAYERS];
   Int       m_phaseVerChroma[MAX_LAYERS];
-  Bool      m_resamplePhaseSetPresentFlag [MAX_LAYERS];
+  Bool      m_resamplePhaseSetPresentFlag[MAX_LAYERS];
 
   Int       m_inputBitDepth[MAX_NUM_CHANNEL_TYPE];            ///< bit-depth of input file
@@ -169,37 +169,34 @@
 
 public:
-  Void  create    ();                                         ///< create option handling class
-  Void  destroy   ();                                         ///< destroy option handling class
-
-  Void    setAppEncCfg(TAppEncCfg* p) {m_cAppEncCfg = p;          }
-
-  string& getInputFileName()          {return m_inputFileName;       }
-  string& getReconFileName()          {return m_reconFileName;       }
-  Double  getFloatQP()                {return m_fQP;                 }
-  Int     getConfWinLeft()            {return m_confWinLeft;         }
-  Int     getConfWinRight()           {return m_confWinRight;        }
-  Int     getConfWinTop()             {return m_confWinTop;          }
-  Int     getConfWinBottom()          {return m_confWinBottom;       }
-
-  Int     getNumSamplePredRefLayers()    {return m_numSamplePredRefLayers;   }
-  Int*    getSamplePredRefLayerIds()     {return m_samplePredRefLayerIds;    }
-  Int     getSamplePredRefLayerId(Int i) {return m_samplePredRefLayerIds[i]; }
-  Int     getNumMotionPredRefLayers()    {return m_numMotionPredRefLayers;   }
-  Int*    getMotionPredRefLayerIds()     {return m_motionPredRefLayerIds;    }
-  Int     getMotionPredRefLayerId(Int i) {return m_motionPredRefLayerIds[i]; }
-
-  Int     getNumActiveRefLayers()     {return m_numActiveRefLayers;}
-  Int*    getPredLayerIds()           {return m_predLayerIds;     }
-  Int     getPredLayerIdx(Int i)      {return m_predLayerIds[i];  }
-
-  Int     getRepFormatIdx()           { return m_repFormatIdx;  }
-  Void    setRepFormatIdx(Int x)      { m_repFormatIdx = x;     }
-  Void    setSourceWidth(Int x)       { m_iSourceWidth = x;     }
-  Void    setSourceHeight(Int x)      { m_iSourceHeight = x;    }
-  Int     getMaxTidIlRefPicsPlus1()   { return m_maxTidIlRefPicsPlus1; }
+  Void    setAppEncCfg(TAppEncCfg* p)          { m_cAppEncCfg = p;             }
+
+  string& getInputFileName()                   { return m_inputFileName;       }
+  string& getReconFileName()                   { return m_reconFileName;       }
+  Double  getFloatQP() const                   { return m_fQP;                 }
+  Int     getConfWinLeft() const               { return m_confWinLeft;         }
+  Int     getConfWinRight() const              { return m_confWinRight;        }
+  Int     getConfWinTop() const                { return m_confWinTop;          }
+  Int     getConfWinBottom() const             { return m_confWinBottom;       }
+
+  Int     getNumSamplePredRefLayers() const    { return m_numSamplePredRefLayers;   }
+  Int*    getSamplePredRefLayerIds() const     { return m_samplePredRefLayerIds;    }
+  Int     getSamplePredRefLayerId(Int i) const { return m_samplePredRefLayerIds[i]; }
+  Int     getNumMotionPredRefLayers() const    { return m_numMotionPredRefLayers;   }
+  Int*    getMotionPredRefLayerIds() const     { return m_motionPredRefLayerIds;    }
+  Int     getMotionPredRefLayerId(Int i) const { return m_motionPredRefLayerIds[i]; }
+
+  Int     getNumActiveRefLayers() const        { return m_numActiveRefLayers;       }
+  Int*    getPredLayerIds() const              { return m_predLayerIds;             }
+  Int     getPredLayerIdx(Int i) const         { return m_predLayerIds[i];          }
+
+  Int     getRepFormatIdx() const              { return m_repFormatIdx;         }
+  Void    setRepFormatIdx(Int x)               { m_repFormatIdx = x;            }
+  Void    setSourceWidth(Int x)                { m_iSourceWidth = x;            }
+  Void    setSourceHeight(Int x)               { m_iSourceHeight = x;           }
+  Int     getMaxTidIlRefPicsPlus1() const      { return m_maxTidIlRefPicsPlus1; }
 #if LAYER_CTB
-  UInt    getMaxCUWidth()             {return m_uiMaxCUWidth;      }
-  UInt    getMaxCUHeight()            {return m_uiMaxCUHeight;     }
-  UInt    getMaxCUDepth()             {return m_uiMaxCUDepth;      }
+  UInt    getMaxCUWidth() const                { return m_uiMaxCUWidth;         }
+  UInt    getMaxCUHeight() const               { return m_uiMaxCUHeight;        }
+  UInt    getMaxCUDepth() const                { return m_uiMaxCUDepth;         }
 #endif
 }; // END CLASS DEFINITION TAppEncLayerCfg